giram(1)

NAME
giram - Giram Is Really A Modeller

SYNOPSIS
giram [options]

DESCRIPTION

giram is a simple volumic (as opposed as meshed) 3D modeller. It allows you to create a 3D scene which you can save as a POV-Ray source file or AutoCAD DXF.

FRAMES AND VIEWS

When Giram starts, only the Giram Toolbox is open. Choosing File, then New View presents a dialog box offering to display several viewports.

View X-Y
    "Front View", with the X and Y axis of the frame corresponding to the X and Y axis of the monitor. Allows you to adjust an object's horizontal and vertical position.

View X-Z
    "Top View", with the frame's Z axis placed along the monitor's Y axis. Allows you to move an object left/right and forward/backward.

View Z-Y
    "Side View", with the Z axis of the frame placed along the X axis of the monitor, and the Y axis placed normally. Allows you to change the depth and height of objects.

Camera View
    Shows the frame in 3 dimensions. Unlike the other views, objects cannot be translated, rotated, or scaled using the mouse. The position and direction of the camera can be adjusted.

If you leave the drop-down list at its default setting of New Frame, the viewports will show a newly created, empty Frame. Other currently open frames are also available. When a frame is first opened, all the views are shown.

To pan in any of the viewports (except the camera), use the scrollbars along both sides of the window. Zooming can be done by right-clicking within the window and selecting View, then Zoom in or Zoom out. Fit to Selection and Fit to Scene will pan and zoom the viewport appropriately.

SELECTIONS

Before you can modify a scene, you have to tell Giram which objects are going to be modified. This is what the Selection Tool is for. With it you can select an object or group of objects, or change the contents of the current selection. Once selected, objects can be a translated, rotated or scaled.

To select an object, just click on it. By default, all objects under the cursor are selected. As scenes can get quite complicated when displayed in 2D, and shapes are displayed stacked up on top of one another, this may not be what you want. So with Giram you can modify the way objects are selected with the [Shift], the [Ctrl] and [Alt] Modifier keys.

No Modifier
    All the objects under the cursor are selected. Previous selections are forgotten.

[Shift]
    All the objects under the cursor are added to the selection.

[Ctrl]
    All the objects under the cursor are removed from the selection.

[Ctrl]+[Shift]
    Select only the objects that are under the cursor AND were in the previous selection.

[Alt]
    The selection is made by the 'first' object under the cursor - the 'first' object being the one that is higher up in the CSG heiracy (basically the one that was created first). Following clicks in the same spot, with the [Alt] modifier, will select the next object under the cursor and so on...

[Alt]+[Shift]
    The 'first' object under the cursor is added to the current selection. Following clicks in the same spot, with the [Alt]+[Shift] modifier, will add the next object under the cursor to what were the selection before the first click, and so on...

[Alt]+[Ctrl]
    The 'first' object under the cursor is removed from the current selection. Following clicks in the same spot, with the [Alt]+[Ctrl] modifier, will removed the next object under the cursor from the selection as it was before the first click, and so on...

[Alt]+[Ctrl]+[Shift]
    The 'first' object under the cursor will become the new selection, but only if it was already in the previous selection, otherwise nothing is selected. Following clicks in the same spot, with the [Alt]+[Ctrl]+[Shift] modifer, will do the same thing but with the 'next' object.

THE TOOLBOX

The toolbox is the first window to open when Giram starts. Items in its dropdown menu apply to the program as a whole, though some commands will affect the most recently opened file. Giram's toolbox can be set to either static or dynamic mode; to change between them choose Preferences from the File menu.

The "Static Toolbox" shows all the icons in one large block. The problem is that there are quite a few tools to pick from, and the toolbox can take up quite a bit of screen real estate.

The "Dynamic Toolbox" tries to use as little screen space as possible. It puts the tools into categories. The selection tool and the transformations (i.e. move, rotate, and scale) remain in place. The shapes are grouped into categories: 3D shapes, 2D shapes, lathes, lights and patches. To pick a shape from the Dynamic Toolbox which is not visible, right-click on an icon that is in the same class and select the desired shape. A small black triangle in the top-right corner of an icon indicates that it contains shapes other than the one visible.

To align shapes preciscely, use the Snap option located in the pop-up menu's Edit submenu. A grid with the specified sizes can be displayed and objects can be set to "snap" to it.

When the Rotate Tool or Scale Tool is active, a green cross will appear near the currently selected object. This indicates the whereabouts of the 'pivot point' or 'scale centre point' of an object or group of objects.

Move
    To move the current selection, simply drag and drop it to the desired location. Translations can also be performed non-interactivly using the choosing Operations, Translate from the pop-up menu.

Rotate
    To rotate the current selection, press and hold the left mouse button while moving the mouse. The selection will rotate around the pivot point in the plane of the active view. To adjust the pivot point, hold [Ctrl] and click at the new pivot point while the Rotate Tool is active. Choosing Operations, Rotate from the pop-up menu allows rotating a specific number of degrees.

Scale
    To grow or shrink an object, press and hold the left mouse button while moving the mouse. The center (i.e. the point which does not move while scaling) can be set by holding [Ctrl] and clicking. It is also possible to scale an object by choosing Operations, Scale from the pop-up menu and entering the scale amount.

Box To create a new rectangular prism, click the left button to place the first corner, move the cursor, and release the button to place the second corner.

Cylinder
    To create a new cylinder, click to place the center of the cylinder's base, and drag the mouse pointer vertically to set the length and horizontally to set the radius.

Plane
    To create a new infinite plane, click anywhere the viewport which resembles the desired plane. For example, a click in the X-Y view will create an infinite X-Y plane (i.e. with a normal toward the Z vector).

Sphere
    To create a new sphere, click to place the center of the sphere, then drag to choose the radius.

SuperEllipsoid
    Left click to choose the center of the SuperEllipsoid. A dialog box appears asking for two exponents of the superellipsoid. Exponents near zero lead to sharp edge, and exponents greater than two lead to pinchy objects.

Sor Left click to place the Surface of Revolution, and a dialog box appears, allowing modification of the key points and a choice of splines connecting them rather than straight lines.

CSG TREE

The CSG Tree is a window gives you an insight as to how the objects are connected and related. Clicking on an object's name in the CSG Tree selects or deselects the object. Currently its only other use is to allow you to make specific objects invisible by clicking on the eye at the left of each object's row in the "Visible" column. Note that it is possible to have an object invisible but selected. If you modify the selected shapes at this point, the invisible ones will be affected too. The objects dimensions are in the far right column marked "Info", and the centre "Tree" shows the graphic artist's version of a directory tree, and you will find that it works a lot like a File Manager utility. Logical branches of a complex object can be individually opened and closed much as directories are on a hard disk.

Eventually this will be a powerful tool showing the structure of your model and allowing you to assign portions of models to specific groups and boolean operations.

OPTIONS
giram accepts the following options:

-h, --help
    Display this list of commandline options.

-v, --version
    Output version information.

-g, --giramrc giramrc
    Use an alternate giramrc file.

--system-gimprc gimprc
    Use an alternate system gimprc file.

--verbose
    Show startup messages.

-c, --console-messages
    Display warnings to console instead of a dialog box.

--debug-handlers
    Enable non-fatal debugging signal handlers.

--enable-stack-trace [never | query | always>
    Debugging mode for fatal signals.

--display display
    Use the designated X display.

FILES
$HOME/.giram-0.3/giramrc

COPYRIGHT
Copyright © 2001 DindinX Permission to use, copy, modify, and distribute this software and its documentation for any purpose and without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation.

SEE ALSO
povray(1), x-povray(1), giramrc(5)

AUTHOR
The primary author of Giram is

David Odin, a.k.a. DindinX, who can be reached at David.Odin@bigfoot.com.